/* Error Handling
 *
 * create : 95.5.11 (Thu), bgjang@csone
 * modify :
 *
 * All error messages are displayed by using MAerror() and
 * debugMesg() is used for debugging convenience.
 *
 */
#include <stdio.h>
#include <varargs.h>
#include <MAerror.h>

char functionName[L_FUNCNAME+1];

#ifdef	DEBUG
void
debugMesg(va_alist) va_dcl
{
	register char *fmt;
	char buf[512];
	va_list pvar;
	
	va_start(pvar);
	fmt = va_arg(pvar, char *);
	(void) vsprintf(buf, fmt, pvar);
	va_end(pvar);
	fprintf(stdout, "%s", buf);
	fflush(stdout);
}
#else
void debugMesg() {}
#endif


void
setFuncName( funcName )
	char* funcName;
{
	if( strlen(funcName) > L_FUNCNAME ) {
		strncpy( functionName, funcName, L_FUNCNAME );
		functionName[L_FUNCNAME] = '\0';
	} else
		strcpy( functionName, funcName );
}

void
MAerror( va_alist ) va_dcl
{
	static char *kind[] = {"Error", "Warning", "Notify"};
	char *fmt;
	char buf[512];
	char mesgErr[512];
	int severity;		/* 1st arg. */
	int errorCode;		/* 2nd arg. */
	char* fileName;		/* 3rd arg. */
	int lineNo;		/* 4th arg. */
	va_list pvar;

	/* argument handling */
	va_start(pvar);
	severity = va_arg( pvar, int );
	errorCode = va_arg( pvar, int );
	fileName = va_arg( pvar, char *);
	lineNo = va_arg( pvar, int);
	fmt = va_arg( pvar, char *);
	(void) vsprintf( buf, fmt, pvar );
	va_end(pvar);

	sprintf( mesgErr,
	  "%s %d : In %s function, %s\"%s\", line %d ",
	  kind[severity], errorCode, functionName, buf, fileName, lineNo );

	switch( severity ) {
	case END :
		perror( mesgErr );
		exit(1);
	case CON :
		fprintf(stdout, "%s\n", mesgErr);
		break;
	case NOT :
		fprintf(stdout, "%s\n", mesgErr);
		break;
	}
}
