/*------------------------------------------------------*
 *                                                      *
 * Korean Part-Of-Speech Tagger ( KTS ) Version 0.9     *
 *                                                      *
 * Sang Ho Lee                                          *
 *                                                      *
 * jhlee@csone.kaist.ac.kr shlee2@adam.kaist.ac.kr      *
 *                                                      *
 * Computer Systems Lab.                                *
 * Computer Science , KAIST                             *
 *                                                      *
 * ktstbls.h ( Korean POS Tagger Tables Header File )   *
 *                                                      *
 *------------------------------------------------------*/

#ifdef __TAGSET__

char posTags[__NUMOFTAG__][5] = { /* Part Of Speech Tag Set */
	 "INI" , /* 0  */
	 "s,"  , /* 1  */
	 "s."  , /* 2  */
	 "s`"  , /* 3  */
	 "s'"  , /* 4  */
	 "s-"  , /* 5  */
	 "su"  , /* 6  */
	 "sw"  , /* 7  */
	 "sy"  , /* 8  */
	 "f"   , /* 9  */
	 "nnn" , /* 10 */
         "nct" , /* 11 */
	 "nca" , /* 12 */
	 "ncs" , /* 13 */
	 "nc"  , /* 14 */
	 "nq"  , /* 15 */
	 "nbu" , /* 16 */
	 "nb"  , /* 17 */
	 "npp" , /* 18 */
	 "npd" , /* 19 */
	 "nn"  , /* 20 */
	 "pv"  , /* 21 */
	 "pad" , /* 22 */
	 "pa"  , /* 23 */
	 "px"  , /* 24 */
	 "md"  , /* 25 */
	 "mn"  , /* 26 */
	 "m"   , /* 27 */
	 "at"  , /* 28 */
	 "ad"  , /* 29 */
	 "ajw" , /* 30 */
	 "ajs" , /* 31 */
	 "a"   , /* 32 */
	 "i"   , /* 33 */
	 "jc"  , /* 34 */
	 "jcm" , /* 35 */
	 "jcv" , /* 36 */
	 "jca" , /* 37 */
	 "jcp" , /* 38 */
	 "jx"  , /* 39 */
	 "jj"  , /* 40 */
	 "ecq" , /* 41 */
	 "ecs" , /* 42 */
	 "ecx" , /* 43 */
	 "exm" , /* 44 */
	 "exn" , /* 45 */
	 "exa" , /* 46 */
	 "efp" , /* 47 */
	 "ef"  , /* 48 */
	 "xn"  , /* 49 */
	 "xpv" , /* 50 */
	 "xpa" , /* 51 */
	 "xa"  , /* 52 */
	 "FIN" , /* 53 */
	 "int" , /* 54 : Ű  '' */
	 "usy" ,
	 "uf"  ,
	 "unnn"
	 } ; 

char posTagsName[__NUMOFTAG__][20] = { /* Part Of Speech Tag Set */
	 ""             , /* 0  */
	 "ǥ"             , /* 1  */
	 ""             , /* 2  */
	 "µǥ"       , /* 3  */
	 "ݴµǥ"       , /* 4  */
	 "ǥ"           , /* 5  */
	 ""             , /* 6  */
	 "ȭ"         , /* 7  */
	 "Ÿȣ"         , /* 8  */
	 "ܱ"           , /* 9  */
	 ""             , /* 10 */
	 "ð"   , /* 11 */
	 "ۼ"   , /* 12 */
	 "¼"   , /* 13 */
	 ""         , /* 14 */
	 ""         , /* 15 */
	 ""   , /* 16 */
	 ""         , /* 17 */
	 "Ī"       , /* 18 */
	 "ô"       , /* 19 */
	 ""             , /* 20 */
	 ""             , /* 21 */
	 ""       , /* 22 */
	 ""           , /* 23 */
	 ""         , /* 24 */
	 "ð"       , /* 25 */
	 ""         , /* 26 */
	 ""           , /* 27 */
	 "ðλ"         , /* 28 */
	 "úλ"         , /* 29 */
	 "ܾӺλ"     , /* 30 */
	 "Ӻλ"     , /* 31 */
	 "λ"             , /* 32 */
	 "ź"           , /* 33 */
	 ""           , /* 34 */
	 ""       , /* 35 */
	 "ȣ"         , /* 36 */
	 "λ"       , /* 37 */
	 ""       , /* 38 */
	 ""           , /* 39 */
	 ""         , /* 40 */
	 ""   , /* 41 */
	 ""   , /* 42 */
	 ""   , /* 43 */
	 "" , /* 44 */
	 ""   , /* 45 */
	 "λ"   , /* 46 */
	 ""       , /* 47 */
	 ""         , /* 48 */
	 "̻"       , /* 49 */
	 "Ļ̻"   , /* 50 */
	 "Ļ̻" , /* 51 */
	 "λĻ̻"   , /* 52 */
	 ""               , /* 53 */
	 "Ű"         , /* 54 : Ű  '' */
	 } ; 

#else

extern char posTags[__NUMOFTAG__][4] ; 
extern char posTagsName[__NUMOFTAG__][20] ;  

#endif


