/* common.h (commonly used macros, constant)
 *
 * create : 95.5.29 (?), bgjang@csone
 * modify :
 * 95.6.2 (Fri), bgjang@csone - insert CTRL() macro
 * 95.6.4 (Sun), bgjang@csone - move POS part to pos.h
 *
 */
#ifndef __COMMON_H__
#define __COMMON_H__

#ifndef TRUE
#define TRUE  (1)
#endif
#ifndef FALSE
#define FALSE (0)
#endif

#define MIN(X,Y)     (((X)<(Y))?(X):(Y))
#define MAX(X,Y)     (((X)>(Y))?(X):(Y))

#define CTRL(x)      ('x' & 017)


/* global variable declarations --------------------------*/
extern int isInitDict;
extern int isInitToken;
extern int isInitChart;
extern int isInitStack;

extern int isFileOpened;
extern int isUsingCache;

extern int NdictID;       /* normal dictionary */
extern int EdictID;       /* execption dictionary */
extern int UdictID;       /* unknown word dictionary */
extern int IdictID;       /* irregular dictionary */

#include <stdio.h>
extern FILE* fpInput;     /* input from where? file pointer or stdin */

#include "pos.h"
extern char cTable[NUM_POS][NUM_POS];   /* connectivity table */
extern char mTable[NUM_POS][NUM_POS];   /* mTable */



/* environment strings used in MoA */
#define DICT_DIR   "MOA_DICTDIR"
#define CTABLE     "MOA_CTABLE"
#define MTABLE     "MOA_MTABLE"
#define TABLE_DIR  "MOA_TABLEDIR"
#define CACHE      "MOA_CACHE"


/* functions declarations --------------------------------*/

/* MAdo.c */
extern int tokenization();
extern int selectOneWordAndMakeChart(/* SchartID, pLastTailV */);
extern void doIrrExecWordSearch(/* SchartID, TchartID, lastTailV */);
extern void makePTypeCharts(/* SchartID, TchartID, lastTailV, pStackID */);
extern int doNormalWordSearch(/* PchartID, RchartID, lastTailV */);
extern void doPrintResult(/* RchartID, lastTailV */);
extern void doUnknownWordProcessing(/* PchartID, RchartID, lastTailV */);

/* cache.c */
extern void cacheInit();
extern int cacheFind(/* dictID, word, ith, pPos, pFreq */);
extern void cacheDestroy();
#if defined(DEBUG)
extern void cacheDump();
#endif

/* misc.c */
extern void timeStr(/* strp */);

#endif
