#ifndef __CONFIG_H__
#define __CONFIG_H__

/* dictAPI.h ---------------------------------------------------*/

// maximum number of dictionary which is opened concurrently.
// if you close dictionary, then it can be used by the other
// open call. So remember the word concurrently.
// I think 10 is really big one.
//
#if 0
#define MAX_OPEN_DICT    10       /* max # of open dictionary concurrently */
#endif

// initiall size of global variable which is used by
// dictionary APIs. It is byte number. And it will be
// reallocated if it is not enough.
//
#if 0
#define INIT_RESULT_SIZE 20       /* initial size of global var for results */
#endif

/* edgePool.h ----------------------------------------------------*/

// maximum number of edge pool which is used concurrently.
// every edge pool have an unique id. And edge pool is
// handled by its unique id. And this number is the maximum
// number of edge pool's unique id.
//
#if 0
#define MAX_EDGEPOOL 10
#endif

/* token.h ------------------------------------------------------*/

// mximum length of one token's contents, in case korean,
// it is stored in kimmo code, so it can be longer than
// KS code. Surely program check all of these error and
// die gracefully... ;)
//
#if 0
#define MAX_TOKEN_LEN 64
#endif

// initially allocated number of token in list of token data structure
// it is better to high this, if realloc() is called many times.
//
#if 0
#define INIT_TOKEN 4
#endif

/* lex.h --------------------------------------------------------*/

// lex's result string is printed in lexResult global variable
// and returned. This variable's size is the following. If the result
// is not enough to fit in this line, programm will die gracefully.
//
#if 0
#define LEN_LEXRESULT 128
#endif


#endif
