/* dictAPI.h
 *
 * create : 95.5.27, bgjang@csone
 * modify :
 *
 */
#ifndef __DICTAPI_H__
#define __DICTAPI_H__

/* for tuning -------------------------------------------------------*/

#ifndef MAX_OPEN_DICT
#define MAX_OPEN_DICT  10         /* max # of open dictionary concurrently */
#endif

#ifndef INIT_RESULT_SIZE
#define INIT_RESULT_SIZE 20       /* initial size of global var for results */
#endif


/* global variable declaration --------------------------------------*/

extern char* dictResult;          /* this is may not be null-terminated */
extern int dictResultLen;         /* length of dictResult's content */

extern char dictErrorStr[256];    /* set when error is occured */


/* error code -------------------------------------------------------*/

#define D_NO_DATA         2       /* no data in the dictionary */
#define D_ERR_NO          1       /* no error */
#define D_ERR_MAX_OPEN    -1      /* # of open dictionary is maximum */
#define D_ERR_OPEN        -2      /* open failure */
#define D_ERR_MALLOC      -3      /* malloc() error */
#define D_ERR_REALLOC     -4      /* realloc() error */
#define D_ERR_NOT_STR     -5      /* absolete */
#define D_ERR_WRONG_ID    -6      /* dictionary ID is wrong */
#define D_ERR_EXIST_DATA  -7      /* data existed when insert */
#define D_ERR_INSERT      -8      /* error when dbm_store() */
#define D_ERR_DELETE      -9      /* error when dbm_delete() */
#define D_ERR_R_OR_W      -10     /* error when reading or writing database */
#define D_ERR_NOT_EXIST   -11     /* data not existed when modify */
#define D_ERR_MODIFY      -12     /* error when dbm_store() with replace */
#define D_ERR_NO_CONTENTS -13     /* no contents although there is keyword */


/* function delcarations --------------------------------------------*/


#endif
