/* token.h -- header file for token.c
 *
 * create : 95.5.30 (Tue), bgjang@csone
 * modify :
 *
 */

#ifndef __TOKEN_H__
#define __TOKEN_H__

// mximum length of one token's contents, in case korean,
// it is stored in kimmo code, so it can be longer than
// KS code. Surely program check all of these error and
// die gracefully... ;)
//
#ifndef MAX_TOKEN_LEN
#define MAX_TOKEN_LEN 64
#endif

// initially allocated number of token in list of token data structure
// it is better to high this, if realloc() is called many times.
//
#ifndef INIT_TOKEN
#define INIT_TOKEN 4
#endif

//------------------------------------------------------------------
// kind of token 
//
// K : korean
// S : symbol
// E : english including hyphen
// N : number such as 1234, .2345, 123., 1,234,567.98
//------------------------------------------------------------------

#define NUM_TOKENTYPE   4

enum tokenType {tokenK, tokenS, tokenE, tokenN};

extern char *tokenTypeStr[];
extern char tokenErrorStr[];

typedef struct {
    enum tokenType tt;
    char string[MAX_TOKEN_LEN];   /* in kimmo code */
} aToken;

extern aToken *tokenList;         /* list of tokens */
extern int tokenNumber;           /* number of current tokens */


/* functions declarations -------------------------------------------*/
extern void tokenDump();
extern void tokenDestroy();
extern int tokenInit();
extern int tokenMake();
extern void tokenSetInput();


/* error code -------------------------------------------------------*/

#define T_NO_DATA          2
#define T_ERR_NO           1
#define T_ERR_MALLOC       -1
#define T_ERR_REALLOC      -2
#define T_ERR_MAXTOKENLEN  -3
#define T_ERR_LEXOUTPUT    -4  // lex output form is wrong
#define T_ERR_TOKENTYPE    -5
#define T_ERR_LEXOUTPUTSIZE -6 // lex output is too big


#endif
