/* stack for interger values
 *
 * create : 95.6.12 (Mon), bgjang@csone
 * modify :
 * 95.6.26 (Mon), bgjang@csone - add isGetIth() although it breaks stack ADT.
 * 95.6.26 (Mon), bgjang@csone - version 0.5 alpha
 *
 *
 * 'is' means integer stack.
 *
 * only positive value's can be placed in stack.
 *
 */

#ifndef MAX_ELTS
#define MAX_ELTS 100
#endif

#ifndef MAX_STACK
#define MAX_STACK 5
#endif

static int stack[MAX_STACK][MAX_ELTS];
static int curPos[MAX_STACK];

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef FAIL
#define FAIL -1
#endif



void isInit()
{
    register int i;

    for( i=0; i<MAX_STACK; i++ )
        curPos[i] = -1;
}

/* return one stack ID if there is free stack.
 * else return fail value
 */
int isCreate()
{
    register int i;

    for( i=0; i<MAX_STACK; i++ )
        if( curPos[i] == -1 ) {
            curPos[i] = 0;
            return i;
        }

    return -1;
}

void isDestroy( id )
    int id;
{
    if( isCheckID( id ) == FALSE ) return;
    curPos[id] = -1;
}

int isIsFull( id )
    int id;
{
    if( isCheckID( id ) == FALSE ) return FAIL;

    if( curPos[id] >= MAX_ELTS ) return TRUE;
    else return FALSE;
}

int isIsEmpty( id )
    int id;
{
    if( isCheckID( id ) == FALSE ) return FAIL;

    if( curPos[id] == 0 ) return TRUE;
    else return FALSE;
}

int isPush( id, value )
    int id;
    int value;
{
    if( isCheckID( id ) == FALSE ) return FAIL;

    if( isIsFull( id ) == FALSE ) {
        stack[id][curPos[id]++] = value;
        return TRUE;
    }
    else
        return FALSE;
}

int isTop( id, pVal )
    int id;
    int *pVal;
{
    if( isCheckID( id ) == FALSE ) return FAIL;

    if( isIsEmpty( id ) == FALSE ) {
        *pVal = stack[id][curPos[id]-1];
        return TRUE;
    } else
        return FALSE;
}

int isPop( id, pVal )
    int id;
    int *pVal;
{
    if( isCheckID( id ) == FALSE ) return FAIL;

    if( isIsEmpty( id ) == FALSE ) {
        *pVal = stack[id][--curPos[id]];
        return TRUE;
    }
    else
        return FALSE;
}

int isGetIth( id, ith, pVal )
    int id;
    int ith;
    int *pVal;
{
    if( isCheckID( id ) == FALSE ) return FAIL;

    if( ith >= curPos[id] ) return FALSE;
    else {
        *pVal = stack[id][ith];
        return TRUE;
    }
}

int isCheckID( id )
{
    if( id >= 0 && id < MAX_STACK ) return TRUE;
    else return FALSE;
}
