/* ordered set for MoA
 *
 * create : 95.6.3 (Sat), bgjang@csone
 * modify :
 * 95.6.19 (Mon), bgjang@csone - orderedDeleteBigValueThan()
 * 95.6.24 (Sat), bgjang@csone - shorten the function name, error variable name
 * 95.6.26 (Mon), bgjang@csone - version 0.5 alpha
 *
 * note :
 * It is only for MoA, so limited in usage, I think. But
 * it have enough capability for MoA.
 *
 */

#include "orderedSet.h"

#ifndef MAX_ELTS
#define MAX_ELTS  200
#endif

char oErrorStr[256];

static int usedElts;        // how many elts are in this set ?
static int curElts;         // current elements ?
static int elts[MAX_ELTS];

oCreate()
{
    register int i;
    for( i=0; i<MAX_ELTS; i++ )
        elts[i] = -1;

    curElts = -1;
    usedElts = 0;
}

oInsert( val )
    int val;
{
    register int i;

    if( usedElts >= MAX_ELTS ) {
        sprintf( oErrorStr, "max elements are used now.\n" );
        return O_ERR_FULL;
    }

    for( i=usedElts-1; i>=0; i-- ) {
        if( elts[i] > val ) elts[i+1] = elts[i];
        else if( elts[i] < val ) { elts[i+1] = val; break; }
        else {
            sprintf( oErrorStr, "ordered set is an set, so elements must be unique.\n" );
            return O_ERR_SET;
        }
    } 
    if( i == -1 ) elts[0] = val;

    usedElts++;
    // curElts are not set by this function.

    return O_ERR_NO;
}

// oDelete()
//

/* delete the values in ordered set which value is
 * bigger than 'val'.
 *
 * Caution : 'val' is not deleted.
 */
void oDeleteBigValueThan( val )
    int val;
{
    register int i;
    for( i=0; i<usedElts; ) {

        /* bigger then delete
         */
        if( elts[i] > val ) {
            elts[i] = elts[usedElts-1];
            elts[--usedElts] = -1;
        }
        else
            i++;
    }
}

oExist( val )
    int val;
{
    register int i;
    for( i=0; i<usedElts; i++ )
        if( elts[i] == val ) return 1;
    return 0;
}

oGetFirst( pVal )
    int *pVal;
{
    if( !(usedElts > 0) ) return O_NO_DATA;
    curElts = 0;

    *pVal = elts[curElts++];
    return O_ERR_NO;
}

oGetNext( pVal )
    int *pVal;
{
    if( curElts >= usedElts ) return O_NO_DATA;

    *pVal = elts[curElts++];
    return O_ERR_NO;
}

oDump()
{
    register int i;
    for( i=0; i<usedElts; i++ )
        printf("%d ", elts[i]);
    putchar('\n');
}
